/*  Gtk+ Widget Factory
 *  Copyright (C) 1999-2000  Jeroen Benckhuijsen
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include "gwf_format.h"
#include <gtk/gtk.h>
#include <stdio.h>

gint
gwf_format_load(GwfError *error,gchar *filename,gchar **xml)
{
  FILE		*ifp;
  GString	*str;
  gchar		buf[1025] = "";

  g_return_val_if_fail(error != NULL,0);
  g_return_val_if_fail(filename != NULL,0);
  g_return_val_if_fail(xml != NULL,0);

  ifp = fopen(filename,"rt");
  if (!ifp)
  {
    gwf_error_raise_error(error,"Format : Load : Can't open");
    return 0;
  }

  str = g_string_new(NULL);
  while (fread((void*)buf,sizeof(gchar),1024,ifp) == 1024)
  {
    g_string_append(str,buf);
    memset((void*)buf,0,sizeof(gchar) * 1025);
  }
  g_string_append(str,buf);

  *xml = str->str;
  g_string_free(str,FALSE);

  fclose(ifp);

  return 1;
}

gint
gwf_format_save(GwfError *error,gchar *filename,gchar *xml)
{
  FILE		*ofp;
  gint		err = 1;

  g_return_val_if_fail(error != NULL,0);
  g_return_val_if_fail(filename != NULL,0);
  g_return_val_if_fail(xml != NULL,0);

  ofp = fopen(filename,"wt");
  if (!ofp)
  {
    gwf_error_raise_error(error,"Format : Save : Can't open");
    return 0;
  }

  if (fwrite((void*)xml,sizeof(gchar),strlen(xml),ofp) != strlen(xml))
  {
    gwf_error_raise_error(error,"Format : Save : Can't write");
    err = 0;
  }

  fclose(ofp);

  return err;
}
