/*  Gtk+ Widget Factory
 *  Copyright (C) 1999-2000  Jeroen Benckhuijsen
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef GWF_PROJDATA_H
#define GWF_PROJDATA_H

#ifdef __cplusplus
extern "C" {
#endif

#include <gtk/gtk.h>

typedef struct	_GwfProjData		GwfProjData;
typedef struct	_GwfDataList		GwfDataList;
typedef void		(*GwfDataFreeFunc)		(gpointer data);
typedef void		(*GwfDataForeachFunc)		(GwfProjData *data,gpointer user_data);

struct _GwfProjData {
   gchar		*name;
   gboolean		active;
   gpointer		data;
   GwfDataFreeFunc	free_func;
};

struct _GwfDataList {
   GHashTable		*data;
};

GwfDataList*	gwf_data_list_new		(void);
void		gwf_data_list_free		(GwfDataList *list);

gint		gwf_data_list_insert		(GwfDataList *list,GwfProjData *data);
void		gwf_data_list_remove		(GwfDataList *list,gchar *name);
GwfProjData*	gwf_data_list_get		(GwfDataList *list,gchar *name);
gpointer	gwf_data_list_get_data		(GwfDataList *list,gchar *name);
void		gwf_data_list_foreach		(GwfDataList *list,GwfDataForeachFunc func,gpointer user_data);

GwfProjData*	gwf_proj_data_new		(gchar *name);
void		gwf_proj_data_free		(GwfProjData *data);
void		gwf_proj_data_set_data		(GwfProjData *data,gpointer dat);
void		gwf_proj_data_set_free_func	(GwfProjData *data,GwfDataFreeFunc func);
gpointer	gwf_proj_data_get_data		(GwfProjData *data);
void		gwf_proj_data_set_active	(GwfProjData *data,gboolean active);
gboolean	gwf_proj_data_get_active	(GwfProjData *data);

#ifdef __cplusplus
}
#endif

#endif

